<?php
// Uncomment next line if you want to use this script!
exit;

require_once("../config.php");

function searchURNEntry($lm,$urnvalue) {
	GLOBAL $URN_LDAP_BASE;

	$selurn = "";
	$found = false;
	$searchurn = $urnvalue;
	while ($found==false&&strcmp($searchurn,"")!=0) {
		$filter="(urnRegValue=".$searchurn.")";
		$entries=$lm->search($URN_LDAP_BASE,$filter);
		if (count($entries)==1) {
			$urn=$entries[0];
			$selurn=$urn;
			$found=true;
		}
		else {
			$temp = explode(":",$searchurn);
			array_pop($temp);
			$searchurn = implode(":",$temp);
		}
	}
	
	return $selurn;
}

function uuid() {
    
    // The field names refer to RFC 4122 section 4.1.2

    return sprintf('%04x%04x-%04x-%03x4-%04x-%04x%04x%04x',
        mt_rand(0, 65535), mt_rand(0, 65535), // 32 bits for "time_low"
        mt_rand(0, 65535), // 16 bits for "time_mid"
        mt_rand(0, 4095),  // 12 bits before the 0100 of (version) 4 for "time_hi_and_version"
        bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)), '01', 6, 2)),
            // 8 bits, the last two of which (positions 6 and 7) are 01, for "clk_seq_hi_res"
            // (hence, the 2nd hex digit after the 3rd hyphen can only be 1, 5, 9 or d)
            // 8 bits for "clk_seq_low"
        mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535) // 48 bits for "node"  
    );  
}

function addUrnReg($lm,$urnvalue,$urndesc) {
	GLOBAL $URN_VALUE_BASE;
	GLOBAL $URN_LDAP_BASE;

	$error="";
	
	$objectClasses = array('urnRegDescriptionStr','urnRegContactPerson','irisObject','top','schacUserEntitlements');
	$uuid=uuid();
	$attrs = array();
	$address=$_REQUEST["pa"];
	$tokenAddress=explode("\n",$address);
	$address=implode(" $ ",$tokenAddress);
	$address.=" $ ".$_REQUEST["co"];
	
	if (strcmp($urnvalue,"")==0) {
		$error="The URN is not valid";
	}
	else if (strcmp($urndesc,"")==0) {
		$error="The description of the URN is not valid";
	}
	else if (strcmp($_REQUEST["cn"],"")==0) {
		$error="The common name of the contact person is not valid";
	}
	else if (strcmp($_REQUEST["em"],"")==0) {
		$error="The email of the contact person is not valid";
	}
	else if (strcmp($_REQUEST["sn1"],"")==0) {
		$error="The first surname of the contact person is not valid";
	}
	else if (strcmp($_REQUEST["gn"],"")==0) {
		$error="The given name of the contact person is not valid";
	}
	else if (strcmp($_REQUEST["pa"],"")==0) {
		$error="The postal address of the contact person is not valid";
	}
	else if (strcmp($_REQUEST["co"],"")==0) {
		$error="The country of the contact person is not valid";
	}
	else if (is_string(searchURNEntry($lm,$urnvalue))==false) {
		$error="The URN ".$urnvalue." is already registered or is still pending approval. ";
	}
	else {
		$attrs['urnRegValue']=array(utf8_encode($urnvalue));
		$attrs['urnRegValueDescription']=array(utf8_encode($urndesc));
		$attrs['cn']=array(utf8_encode($_REQUEST["cn"]));
		$attrs['givenName']=array(utf8_encode($_REQUEST["gn"]));
		$attrs['idnc']=array(utf8_encode($uuid));
		$attrs['mail']=array(utf8_encode($_REQUEST["em"]));
		$attrs['postalAddress']=array(utf8_encode($address));
		$attrs['schacSn1']=array(utf8_encode($_REQUEST["sn1"]));
		if (strcmp($_REQUEST["sn2"],"")!=0)
			$attrs['schacSn2']=array(utf8_encode($_REQUEST["sn2"]));
		if (strcmp($_REQUEST["ph"],"")!=0)
			$attrs['telephoneNumber']=array(utf8_encode($_REQUEST["ph"]));
	
		$res=$lm->addEntry("idnc=".$uuid.",".$URN_LDAP_BASE,$objectClasses,$attrs);
		if ($res==false) {
			$error="Error adding the entry into the LDAP";
		}
	}
	
	return $error;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title>URNreg</title>
	<style type="text/css">
    
html, body { 
    font-family:verdana, arial, helvetica, sans-serif;
    font:11px/14px verdana, arial, helvetica, sans-serif;
    margin: 0;
    height:100%;
    color: white;
    background: #808080;
}

body div#main {
	margin: auto;
	width: 780px;
    background: #ffffff;
}

div#main div#header {
	background: #ECFFE6;
	background: #f7f7f7;
	border-bottom: 4px solid #ADC7A6;
}

div#main div#header div#headercontent {
	margin-left: 24px;
	background: url(browser/imgs/logo-urnreg.png) no-repeat center left;
	position: relative;
	text-align: right;
	color: black;
	font-size: 18px;
	padding: 16px;
}

div#main div#header div#headerthing {
	height: 8px;
	background: #5F9410;
}

div#content {
	color: black;
	padding: 12px; 
}

div#urnbox {
	padding: 12px;
	background-color: #fafafa;
	position: relative;
}

div.box {
	background: #f0f4f0;
	border: 1px solid #d0d4d0;
	padding: 8px;
}

div.notroot {
	margin-top: 8px;
}

div.infoblock {
	padding-bottom: 8px;
}

div.infoleftcol {
	font-weight: bold;
	padding-bottom: 4px;
}
 
div.leftcol {
	position: absolute;
	margin-left: 24px;
}

div.leftcol input {
	border: 1px solid black;
}

div.rightcol {
	margin-left: 18em;
}

div.rightcol input {
	border: 1px solid black;
	width: 300px;
}

div.rightcol textarea {
	border: 1px solid black;
	width: 300px;
	height: 120px;
	overflow: auto;
}

div#machine {
	padding-top: 8px;
	text-align: center;
}

h4 {
	font-size: 120%;
	margin-top: 0;
}

span.ok {
	margin-left: 12px;
	color: green;
}

span.bad {
	margin-left: 12px;
	color: red;
}

div.finalmessage {
	padding: 12px;
}
	</style>
</head>
<body>
	<div id="main">
		<div id="header">
			<div id="headerthing">&nbsp;</div>
			<div id="headercontent">Install URNreg</div>
		</div>
		<div id="content">
			<p>This is the installation script for URNreg, where you can check your <i>config.php</i> file and create an initial URN entry in your LDAP.</p>
<?php
if (array_key_exists("urnvalue0",$_REQUEST)) {
?>
			<div class="box">
				<h4>Adding root entries</h4>
				<div class="infoblock">
					<div class="infoleftcol">The next URNs are going to be installed right now.</div>
<?php
	require_once($siledap_path."/LdapConf.php");
	require_once($siledap_path."/LdapManager.php");

	$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
	$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
	$lm->connectLdap($LDAP_USER,$LDAP_PASS);
	
	$i=0;
	while (array_key_exists("urnvalue".$i,$_REQUEST)) {
		if (array_key_exists("urndesc".$i,$_REQUEST)) {
?>
					<div>
						<div class="leftcol"><?php echo $_REQUEST["urnvalue".$i]; ?></div>
<?php
			$error=addUrnReg($lm,$_REQUEST["urnvalue".$i],$_REQUEST["urndesc".$i]);
?>
						<div class="rightcol"><input type="text" value="<?php if (strcmp($error,"")==0) echo "No error"; else echo $error; ?>" />
<?php
						if (strcmp($error,"")==0) {
							echo "<span class='ok'>OK</span>";
						}
						else {
							echo "<span class='bad'>Fail</span>";
						}
?>
						</div>
					</div>
<?php
		}
		$i++;
	}
?>
				</div>
			</div>
			<div class="box notroot">
<?php
}
?>
			<div class="box">
<?php

$error=false;

?>
				<h4>Configuration of URNreg</h4>
				<div class="infoblock">
					<div class="infoleftcol">The absolute path of web content of URNreg</div>
					<div>
						<div class="leftcol">$urnreg_path</div>
						<div class="rightcol"><input type="text" name="urnreg_path" value="<?php echo $urnreg_path; ?>" />
						<?php
							if (file_exists($urnreg_path)&&file_exists($urnreg_path."/common.php")) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">The absolute path of the siledap_api folder</div>
					<div>
						<div class="leftcol">$siledap_path</div>
						<div class="rightcol"><input type="text" name="siledap_path" value="<?php echo $siledap_path; ?>" />
						<?php
							if (file_exists($siledap_path)&&file_exists($siledap_path."/LdapConf.php")) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">DN base for managing the entries (URNs) in the LDAP</div>
					<div>
						<div class="leftcol">$URN_LDAP_BASE</div>
						<div class="rightcol"><input type="text" name="URN_LDAP_BASE" value="<?php echo $URN_LDAP_BASE; ?>" />
						<?php
							if (is_string($URN_LDAP_BASE)&&strcmp($URN_LDAP_BASE,"")!=0) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">Root namespaces managed by URNreg, separated by commas</div>
					<div>
						<div class="leftcol">$URN_VALUE_BASE</div>
						<div class="rightcol"><input type="text" name="URN_VALUE_BASE" value="<?php echo implode(",",$URN_VALUE_BASE); ?>" />
						<?php
							if (is_array($URN_VALUE_BASE)&&count($URN_VALUE_BASE)>0) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
			</div>
			<div class="box notroot">
				<h4>Configuration of siLeDAP API library</h4>
<?php
	require_once($siledap_path."/LdapConf.php");
?>
				<div class="infoblock">
					<div class="infoleftcol">LDAP server address</div>
					<div>
						<div class="leftcol">$LDAP_SERVER_NAME</div>
						<div class="rightcol"><input type="text" name="LDAP_SERVER_NAME" value="<?php echo $LDAP_SERVER_NAME; ?>" />
						<?php
							if (strcmp($LDAP_SERVER_NAME,"")!=0) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">LDAP server port</div>
					<div>
						<div class="leftcol">$LDAP_SERVER_PORT</div>
						<div class="rightcol"><input type="text" name="LDAP_SERVER_PORT" value="<?php echo $LDAP_SERVER_PORT; ?>" />
						<?php
							if (is_int($LDAP_SERVER_PORT)&&$LDAP_SERVER_PORT>0&&$LDAP_SERVER_PORT<65535) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">LDAP bind DN</div>
					<div>
						<div class="leftcol">$LDAP_USER</div>
						<div class="rightcol"><input type="text" name="LDAP_USER" value="<?php echo $LDAP_USER; ?>" />
						<?php
							if (strcmp($LDAP_USER,"")!=0) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">LDAP bind password</div>
					<div>
						<div class="leftcol">$LDAP_PASS</div>
						<div class="rightcol"><input type="password" name="LDAP_PASS" value="<?php echo $LDAP_PASS; ?>" />
						<?php
							if (strcmp($LDAP_PASS,"")!=0) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">LDAP DN base</div>
					<div>
						<div class="leftcol">$LDAP_DN_BASE</div>
						<div class="rightcol"><input type="text" name="LDAP_DN_BASE" value="<?php echo $LDAP_DN_BASE; ?>" />
						<?php
							if (strcmp($LDAP_PASS,"")!=0) {
								echo "<span class='ok'>OK</span>";
							}
							else {
								$error=true;
								echo "<span class='bad'>Fail</span>";
							}
						?>
						</div>
					</div>
				</div>
			</div>
			<div class="box notroot">
				<h4>Configuration of URNreg Browser</h4>
<?php
if (isset($API_URI_BASE)||isset($SILEDAP_WS_URI_BASE)||isset($EMAIL_SENDER)||isset($EMAIL_BCC)||isset($EMAIL_SUBJECT)||isset($EMAIL_TEXT)||isset($EMAIL_REJECT_TEXT)||isset($EMAIL_ACCEPT_TEXT)) {
?>
				<div class="infoblock">
					<div class="infoleftcol">URI base for the web services</div>
					<div>
						<div class="leftcol">$API_URI_BASE</div>
						<div class="rightcol"><input type="text" name="API_URI_BASE" value="<?php echo $API_URI_BASE; ?>" /></div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">URI base for siLeDAP web services</div>
					<div>
						<div class="leftcol">$SILEDAP_WS_URI_BASE</div>
						<div class="rightcol"><input type="text" name="SILEDAP_WS_URI_BASE" value="<?php echo $SILEDAP_WS_URI_BASE; ?>" /></div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">Sender's email when a request is accepted</div>
					<div>
						<div class="leftcol">$EMAIL_SENDER</div>
						<div class="rightcol"><input type="text" name="EMAIL_SENDER" value="<?php echo $EMAIL_SENDER; ?>" /></div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">Administrator's email when a request is accepted</div>
					<div>
						<div class="leftcol">$EMAIL_BCC</div>
						<div class="rightcol"><input type="text" name="EMAIL_BCC" value="<?php echo $EMAIL_BCC; ?>" /></div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">Subject of email when a request is accepted</div>
					<div>
						<div class="leftcol">$EMAIL_SUBJECT</div>
						<div class="rightcol"><input type="text" name="EMAIL_SUBJECT" value="<?php echo $EMAIL_SUBJECT; ?>" /></div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">Text of email when a request is received</div>
					<div>
						<div class="leftcol">$EMAIL_TEXT</div>
						<div class="rightcol"><textarea name="EMAIL_TEXT"><?php echo $EMAIL_TEXT; ?></textarea></div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">Text of email when a request is rejected</div>
					<div>
						<div class="leftcol">$EMAIL_REJECT_TEXT</div>
						<div class="rightcol"><textarea name="EMAIL_REJECT_TEXT"><?php echo $EMAIL_REJECT_TEXT; ?></textarea></div>
					</div>
				</div>
				<div class="infoblock">
					<div class="infoleftcol">Text of email when a request is accepted</div>
					<div>
						<div class="leftcol">$EMAIL_ACCEPT_TEXT</div>
						<div class="rightcol"><textarea name="EMAIL_ACCEPT_TEXT"><?php echo $EMAIL_ACCEPT_TEXT; ?></textarea></div>
					</div>
				</div>
<?php
}
else {
?>
				<div class="infoblock">
					<div>You don't have configuration parameters for URNreg browser</div>
				</div>
<?php
}
?>
			</div>
			<div class="box notroot">
				<h4>Install root urns</h4>
<?php
if ($error==true) {
?>
				<div class="infoblock">
					<div>Your configuration is not okay. Please, read the documentation and update the parameters.</div>
				</div>
<?php
}
else {
?>
				<form action="install.php" method="post">
				<div class="infoleftcol">URNs information</div>
					<div class="infoblock" style="color: #3a7fff;">
						<div class="leftcol">Value</div>
						<div class="rightcol">Description</div>
					</div>
<?php
	require_once($urnreg_path."/common.php");
	require_once($siledap_path."/LdapManager.php");
	
	$lm=new LdapManager($LDAP_SERVER_NAME,$LDAP_SERVER_PORT);
	$lm->setOption(LDAP_OPT_PROTOCOL_VERSION,3);
	$lm->connectLdap($LDAP_USER,$LDAP_PASS);
	$i=0;
	$alls=true;
	foreach ($URN_VALUE_BASE as $urn) {
		$dataurn=searchURNEntry($lm,$urn);
?>
					<div class="infoblock">
						<div class="leftcol"><input type="text" value="<?php echo $urn; ?>" name="urnvalue<?php echo $i; ?>" class="inputtext" readonly="true" /></div>
<?php
		if (is_string($dataurn)) {
			$alls=false;
?>
						<div class="rightcol"><input type="text" value="<?php if (array_key_exists('urndesc'.$i,$_REQUEST)) echo $_REQUEST['urndesc'.$i]; ?>" name="urndesc<?php echo $i; ?>" class="inputtext" /></div>
<?php
		}
		else {
?>
						<div class="rightcol">URN already added</div>
<?php
		}
?>
					</div>
<?php
		$i++;
	}
	if ($alls==false) {
?>
					<div class="infoleftcol">Register contact person</div>
						<div class="infoblock">
							<div class="leftcol">Common name</div>
							<div class="rightcol"><input type="text" value="<?php if (array_key_exists('cn',$_REQUEST)) echo $_REQUEST['cn']; ?>" name="cn" class="inputtext" /></div>
						</div>
						<div class="infoblock">
							<div class="leftcol">Given name</div>
							<div class="rightcol"><input type="text" value="<?php if (array_key_exists('gn',$_REQUEST)) echo $_REQUEST['gn']; ?>" name="gn" class="inputtext" /></div>
						</div>
						<div class="infoblock">
							<div class="leftcol">First surname</div>
							<div class="rightcol"><input type="text" value="<?php if (array_key_exists('sn1',$_REQUEST)) echo $_REQUEST['sn1']; ?>" name="sn1" class="inputtext" /></div>
						</div>
						<div class="infoblock">
							<div class="leftcol">Second surname</div>
							<div class="rightcol"><input type="text" value="<?php if (array_key_exists('sn2',$_REQUEST)) echo $_REQUEST['sn2']; ?>" name="sn2" class="inputtext" /></div>
						</div>
						<div class="infoblock">
							<div class="leftcol">Postal address</div>
							<div class="rightcol"><textarea name="pa" class="inputtext" ><?php if (array_key_exists('pa',$_REQUEST)) echo $_REQUEST['pa']; ?></textarea></div>
						</div>
						<div class="infoblock">
							<div class="leftcol">Country</div>
							<div class="rightcol"><input type="text" value="<?php if (array_key_exists('co',$_REQUEST)) echo $_REQUEST['co']; ?>" name="co" class="inputtext" /></div>
						</div>
						<div class="infoblock">
							<div class="leftcol">Phone</div>
							<div class="rightcol"><input type="text" value="<?php if (array_key_exists('ph',$_REQUEST)) echo $_REQUEST['ph']; ?>" name="ph" class="inputtext" /></div>
						</div>
						<div class="infoblock">
							<div class="leftcol">Email</div>
							<div class="rightcol"><input type="text" value="<?php if (array_key_exists('em',$_REQUEST)) echo $_REQUEST['em']; ?>" name="em" class="inputtext" /></div>
						</div>
				<div style="text-align: center;">
					<input type="submit" value="Add URNs"/>
				</div>
<?php
	}
	else {
?>
				<div class="finalmessage">Congratulations, your system is ready! You don't need to add the root urns.</div>
<?php
	}
?>
				</form>
<?php
}
?>
			</div>
		</div>
	</div>
</body>
</html>